Attribute VB_Name = "Module1"


' DefSng A-H, M-Z
' DefInt I-K
'                       HUBBLE.BAS
'       Revision 1.0    Original                         11 Feb 1996
'
' DECLARE SUB COORD (m0!, m1!, dist!, x0!, x1!, vy0!, vy1!)
' DECLARE SUB GETSCREEN ()
' DECLARE SUB INITIALISE ()
Public m(10), m0(10)
Public x0(10), x1(10), y0(10), y1(10), x2(10), y2(10)
Public vx0(10), vx1(10), vy0(10), vy1(10), vv(10), vvmax(10)
Public x00(10), y00(10)                           ' initial position
Public vx00(10), vy00(10)                         ' initial velocity
Public xx0(10, 2), yy0(10, 2), rx(10, 10), rr2limit(2, 2)
Public alphaa(5), listt
Const pi = 3.141592653589
Public t, tcnt, TT, TT1                         ' t + tdelta
Public G, initcond, state, msun
Public stars, nstars
Public tdelta
Public scren%, subtest
Public dispcond                                 ' - 1 once each rev
Public dist1              ' distance 1
Public dist2, dist22      ' distance 2
Public agrad, alpha0, alpha, dalpha0, alpha0str, alpha0end                    ' alpha
Public xmax, ymax, fract
Public x0disp, y0disp, scalex, scaley
Public x0disp3, y0disp3, scalex3, scaley3, x0disp31, y0disp31
Public end1, endc                              ' endc for commands
Public black, blue, green, cyan, grijs, red, yellow
Public l_blue, l_green, l_red, magenta
Public rrmin, rrmint0, rrmint1
Public ratio, rrmin20, rrmin21, rrmin201, rrlimit, m1fract, m2fract, m3fract
Public vlimit, vlimitmax
Public escape, bhfract, au, auc, auc1, trace
Public manual0, manual, dist2f, tdelta_fact, html, ncycle    ' m3fract > bhfract
Public mul0, mul1, mul2, mul_dist2

Sub Main()

Const ESC = 27, ENTER = 13

Dim ax(10), ay(10)
Dim Sax(10), Say(10)                           ' sum of ax integrated
Dim Ssax(10), Ssay(10)                         ' sum of sum ax integrated
Dim Sva(10), Svy(10)                           ' sum of vx integrated
Dim rr(10, 10), dx(10, 10), dy(10, 10), r(10, 10)
Dim title$

title$ = "3 Objects m0, m1 and m2 Demonstration"
grijs = RGB(12 * 16, 12 * 16, 12 * 16)
black = QBColor(0): blue = QBColor(1): green = QBColor(2): cyan = QBColor(3): red = QBColor(4)
magenta = QBColor(5): brown = QBColor(6): white = QBColor(7)
l_blue = QBColor(9): l_green = QBColor(10): l_red = QBColor(12): l_magenta = QBColor(13)
l_yellow = QBColor(14): l_white = QBColor(15)

Form2.Visible = True
Form3.Visible = True

' subtest = Val(Form1.Text1(10).Text)
' If subtest <> 0 Then INIT0
INIT1
Form2.Cls: Screen scren%
    
s0:

ratio = 0

s1:
INITIALISE                             ' Part 2

' If m1fract > bhfract Then Form2.Cls

If color15 <> 15 Then color15 = 15 Else color15 = 7
If COLOR12 <> 12 Then COLOR12 = 12 Else COLOR12 = 12
If COLOR10 <> 10 Then COLOR10 = 10 Else COLOR10 = 10
color 15
If trace = 1 Then Debug.Print title$; "  m(0)"; m(0); "m(1)"; m(1); "m(2)"; m(2)
If trace = 1 Then Debug.Print "alpha "; alpha;
If trace = 1 Then Debug.Print "Delta time "; tdelta; dispcond; "# stars "; stars; "ratio"; ratio; "limit"; Sqr(rrlimit); Int(vlimit)
Form3.Text1(0).Text = alpha
If auc = 0 Then
    Form1.Text1(9).Text = Int(Sqr(rrlimit))
    If rrlimit < 100 Then
        Form1.Text1(9).Text = Int(Sqr(rrlimit) * 1000) / 1000
    End If
Else
   Form1.Text1(9).Text = Int(Sqr(rrlimit) * 1000 / au) / 1000
End If
Form1.Text1(8).Text = Int(vlimit / 10) * 10
If tdelta < 0.01 Then
    Form1.Text1(5).Text = Int(tdelta * 10 ^ 7) / 10 ^ 7
Else
    If tdelta > 100 Then
        Form1.Text1(5).Text = Int(tdelta)
    Else
        Form1.Text1(5).Text = Int(tdelta * 10 ^ 3) / 10 ^ 3
    End If
End If
Form1.Text1(6).Text = stars          ' n stars

stars = stars - 1
t = 0: tcnt = 0: state = 0
end1 = 0
time1 = Timer

For i = 0 To stars
  For j = 0 To stars
    If i <> j And m(j) > 0 Then
      ddx = (x00(j) - x00(i))
      ddy = (y00(j) - y00(i))
      rr2 = ddx * ddx + ddy * ddy:
      rr(i, j) = rr2: dx(i, j) = ddx: dy(i, j) = ddy
    End If
  Next j
  x1(i) = x0(i): y1(i) = y0(i)           ' all equal
  x2(i) = x1(i): y2(i) = y1(i)
Next i

For i = 0 To stars
  Sax(i) = 0: Ssax(i) = 0
  Say(i) = 0: Ssay(i) = 0
Next i

' calculate for t = -1

tcnt = -1

  For i = 0 To stars
    ax(i) = 0: ay(i) = 0
    If m(i) >= 0 Then
      For j = 0 To stars
      If i <> j Then
        rr2 = rr(i, j): ddx = dx(i, j): ddy = dy(i, j)
        a = m(j) * G / rr2
        ax(i) = ax(i) + ddx * a / Sqr(rr2)
        ay(i) = ay(i) + ddy * a / Sqr(rr2)
      End If
      Next j
      Sax(i) = Sax(i) + ax(i)
      Say(i) = Say(i) + ay(i)
      Ssax(i) = Ssax(i) + Sax(i)
      Ssay(i) = Ssay(i) + Say(i)
    End If
  Next i
 
  For i = 0 To stars
    x1(i) = x00(i) + tdelta * (tcnt * vx00(i) + tdelta * Ssax(i))
    y1(i) = y00(i) + tdelta * (tcnt * vy00(i) + tdelta * Ssay(i))
    For j = 0 To stars
      If i <> j Then
        ddx = (x00(j) - x00(i)) + tdelta * (tcnt * (vx00(j) - vx00(i)) + tdelta * (Ssax(j) - Ssax(i)))
        ddy = (y00(j) - y00(i)) + tdelta * (tcnt * (vy00(j) - vy00(i)) + tdelta * (Ssay(j) - Ssay(i)))
        rr2 = ddx * ddx + ddy * ddy
        rr(i, j) = rr2: dx(i, j) = ddx: dy(i, j) = ddy
        If rr2 < 1 Then end1 = 1
      End If
    Next j
  Next i

' initialise rr(i,j)
For i = 0 To stars
  For j = 0 To stars
    If i <> j Then
      ddx = (x00(j) - x00(i))
      ddy = (y00(j) - y00(i))
      rr2 = ddx * ddx + ddy * ddy
      rr(i, j) = rr2: dx(i, j) = ddx: dy(i, j) = ddy
    End If
  Next j
Next i

For i = 0 To stars
  Sax(i) = 0: Ssax(i) = 0
  Say(i) = 0: Ssay(i) = 0
  vvmax(i) = 0
Next i

t = 0: tcnt = 0:  nstars = stars + 1
pcnt = 0: end1 = 0: closest = 0
Form1.Text1(6).Text = nstars          ' n stars

str1:
tcnt = tcnt + 1: t = tcnt * tdelta

If end1 = 0 Then
    For i = 0 To stars
        ax(i) = 0: ay(i) = 0
        If m(i) >= 0 Then
            For j = 0 To stars
                If i <> j Then
                    rr2 = rr(i, j)
                    ddx = dx(i, j): ddy = dy(i, j)
                    a = m(j) * G / rr2
                    ax(i) = ax(i) + ddx * a / Sqr(rr2)
                    ay(i) = ay(i) + ddy * a / Sqr(rr2)
                End If
            Next j
            '     vnt  = v0 + (a0 + a1   ...an)t   = v0 + Sax * t
            '     xn   = x0 + nv0 + (n*a0 + n-1*a1 ...    1*an) t  = x0 + n*v0 + SSax*t
            Sax(i) = Sax(i) + ax(i)
            Say(i) = Say(i) + ay(i)
            Ssax(i) = Ssax(i) + Sax(i)
            Ssay(i) = Ssay(i) + Say(i)
            '        vx1(i) = vx0(i) + ax(i) * tdelta
            '        vy1(i) = vy0(i) + ay(i) * tdelta
            '      x0(i) = x00(i) + tdelta * (tcnt * vx00(i) + tdelta * SSax(i))
            '      y0(i) = y00(i) + tdelta * (tcnt * vy00(i) + tdelta * SSay(i))
        End If
    Next i

    'x0(1) = dist1 / 2 * Cos(2 * pi * t / TT + agrad)
    'y0(1) = dist1 / 2 * Sin(2 * pi * t / TT + agrad)
    'x0(0) = -x0(1)
    ' y0(0) = -y0(1)

    For i = 0 To stars
        If m(i) > 0 Then
            x2(i) = x1(i): y2(i) = y1(i)
            x1(i) = x0(i): y1(i) = y0(i)
            x0(i) = x00(i) + tdelta * (tcnt * vx00(i) + tdelta * Ssax(i))
            y0(i) = y00(i) + tdelta * (tcnt * vy00(i) + tdelta * Ssay(i))
            ''x0(i) = x0(i) + tdelta * vx0(i)
            ''y0(i) = y0(i) + tdelta * vy0(i)
            vx1(i) = vx0(i) + Sax(i) * tdelta
            vy1(i) = vy0(i) + Say(i) * tdelta
            vv(i) = Sqr(vx1(i) * vx1(i) + vy1(i) * vy1(i))
            If vv(i) > vvmax(i) Then vvmax(i) = vv(i)
        End If
    Next i
    For i = 0 To stars
        If m(i) > 0 Then
            For j = 0 To stars
                If i <> j And m(j) > 0 Then   ' Test 0,1  0,2  1,0*  1,2  2,0*  2,1*
                    ' ddx = (x00(j) - x00(i)) + tdelta * (tcnt * (vx00(j) - vx00(i)) + tdelta * (Ssax(j) - Ssax(i)))
                    ' ddy = (y00(j) - y00(i)) + tdelta * (tcnt * (vy00(j) - vy00(i)) + tdelta * (Ssay(j) - Ssay(i)))
                    ddx = x0(j) - x0(i)           ' low accuracy
                    ddy = y0(j) - y0(i)           ' low accuracy
                    rr2 = ddx * ddx + ddy * ddy
                    rr(i, j) = rr2
                    dx(i, j) = ddx: dy(i, j) = ddy
                    r(i, j) = Sqr(rr2)
                    If rr2 < rr2limit(i, j) Then
                      If i = 2 Or j = 2 Then
                        nstars = nstars - 1
                        Form1.Text1(6).Text = stars          ' n stars
                        If m(i) < m(j) Then m(i) = 0 Else m(j) = 0
                        Debug.Print "Collision "; i; j; "nstars "; nstars; " rr2 "; Sqr(rr2); "rr2limit"; Sqr(rr2limit(i, j)); m(0); m(1); m(2); Sqr(rrmin20); Sqr(rrmin21)
                        Debug.Print Sqr(rr2limit(0, 2)); Sqr(rr2limit(1, 2)); Sqr(rr2limit(2, 0)); Sqr(rr2limit(2, 1))
                        If i = 0 And j = 2 And rr(0, 2) < rrmin20 Then rrmin20 = rr(0, 2)
                        If i = 1 And j = 2 And rr(1, 2) < rrmin21 Then rrmin21 = rr(1, 2)
                      End If
                   End If
                End If
            Next j
        End If
    Next i
    
    rrmint1 = rrmint0
    rrmint0 = rrmin
    
    If m(0) > 0 Then
        rrmin = rr(0, 2)         ' smallest present distance
        rrmax = rrmin            ' largest present distance
        If m(1) > 0 Then
            If rr(1, 2) < rrmin Then rrmin = rr(1, 2) Else rrmax = rr(1, 2)
        End If
    Else
        rrmin = rr(1, 2)
        rrmax = rrmin
    End If
    If m(0) > 0 And rr(0, 2) < rrmin20 Then rrmin20 = rr(0, 2)
    If m(1) > 0 And rr(1, 2) < rrmin21 Then rrmin21 = rr(1, 2)
    If rrmin20 < rrmin21 Then rrmin201 = rrmin20 Else rrmin201 = rrmin21
  
    If rrmax > dist22 And state = 1 Then          ' No BH in center ??  And
        If m1fract < bhfract Then
            end1 = 1
            Debug.Print "S1 end"; stars; nstars; m(0); m(1); m(2); Sqr(rrmax); "dist2"; Sqr(dist22)
        Else
            end1 = 1
            Debug.Print "S11 end"; stars; nstars; m(0); m(1); m(2); Sqr(rrmax); "dist2"; Sqr(dist22)
        End If
    End If
    If m1fract < bhfract Then
        If rrmax > dist22 / 4 And state = 1 And m3fract > 1 Then
            end1 = 1
            Debug.Print "S2"; stars; nstars; m(0); m(1); m(2); Sqr(rrmax); "dist2"; Sqr(dist22); "state"; state
        End If
    Else
        ''If rrmin20 < rrlimit Then
        ''    end1 = 1
        ''    Debug.Print "S3"; stars; nstars; m(0); m(1); m(2)
        ''End If
    End If
    If nstars = 2 And (m(2) < m(0) Or m1fract > bhfract) Then
        end1 = 1               ' colision HVS
        Debug.Print "S4"; stars; nstars; m(0); m(1); m(2)
    End If
    If nstars = 1 Then
        end1 = 1
        Debug.Print "S5"; stars; nstars; m(0); m(1); m(2)
    End If
    '  If nstars <= 3 Then
       ' If (m(0) > 0 And rr(2, 0) < 200 * rrlimit) Or (m(1) > 0 And rr(2, 1) < 100 * rrlimit) Then
    If rrmin < 5000 * rrlimit Then
        ' If state = 0 Then Debug.Print "State Change 1"
        dispcond = 1: ' state = 1
        If trace = 1 Then
        If rrmin < 100 * rrlimit Then
            If pcnt Mod 5 = 0 Or rrmin < 16 * rrlimit Then
                ' Debug.Print pcnt; Int(Sqr(rrmin)); Int(Sqr(rrmin20)); Int(Sqr(rrmin21)); "vv"; Int(vv(0)); Int(vv(1)); Int(vv(2)); Tab(56); "rr"; Int(r(2, 0)); Int(r(2, 1)) ' ; "m"; m(0); m(1); m(2)
                ' Debug.Print pcnt; Int(Sqr(rrmin)); Int(Sqr(rrmin20)); Int(Sqr(rr(2, 1) / rrlimit) * 100) / 100; "vv"; Int(vv(0)); Int(vv(1)); Int(vv(2)); Tab(60); "rr"; Int(r(2, 0)); Int(r(2, 1)) ' ; "m"; m(0); m(1); m(2)
            End If
            pcnt = pcnt + 1:
            ' If pcnt = 100 * 10 Then end1 = 1
        End If
        End If
    Else
        dispcond = 100
    End If
End If

If rrmin > rrmint0 And rrmint0 < rrmint1 Then
        If m1fract >= bhfract Then
            Debug.Print "Closest approach "; "rmin20"; Int(Sqr(rrmin20 / rrlimit) * 100) / 100; "rmin21"; Int(Sqr(rrmin21 / rrlimit) * 10000) / 10000; "pcnt"; pcnt; "closest"; closest;
            Debug.Print Int(Sqr(rrmin / rrlimit) * 10000) / 10000; Int(Sqr(rrmint0 / rrlimit) * 10000) / 10000; Int(Sqr(rrmint1 / rrlimit) * 10000) / 10000
            closest = closest + 1
            state = 1
            If closest >= ncycle Then end1 = 1
        End If
        ' Debug.Print rrmin; rrmint0; rrmint1
        If rrmin < dist1 * dist1 Then
            ' If state = 0 Then Debug.Print "State Change 2"; rrmin; dist1
            state = 1
        End If
End If


If (tcnt Mod dispcond = 0 And dispcond > 0) Or end1 = 1 Or (dispcond < 0 And prtest% = 1) Then
    DoEvents
    If m1fract < bhfract Then
        vesc0 = Sqr(2 * G * m(2) / Sqr(rr(0, 2)))
        vesc1 = Sqr(2 * G * m(2) / Sqr(rr(1, 2)))
        vesc2 = Sqr(2 * G * (m(0) / Sqr(rr(0, 2)) + m(1) / Sqr(rr(1, 2)))) ' sqr(2GM/r)
        If m(2) = 0 Or m(0) = 0 Then frac0 = 0 Else frac0 = vv(0) / vesc0
        If m(2) = 0 Or m(1) = 0 Then frac1 = 0 Else frac1 = vv(1) / vesc1
        If m(0) = 0 And m(1) = 0 Then frac2 = 0 Else frac2 = vv(2) / vesc2
    Else
        vesc0 = 0: vesc1 = 0: frac0 = 0: frac1 = 0
        vesc2 = Sqr(2 * G * (m(0) / Sqr(rr(0, 2))))  ' sqr(2GM/r)
        If m(0) = 0 Or m(2) = 0 Then frac2 = 0 Else frac2 = vv(2) / vesc2
    End If
  
    If time1 <> Time Or end1 = 1 Then
        time1 = Time
        ' color color15: Locate 2, 40: Debug.Print "cycle "; tcnt; Tab(56); "r #3"; Int(Sqr((rr(2, 0) + rr(2, 1)) / 2))
        Form1.Text1(7).Text = tcnt
  
        ' Locate 3, 20: Debug.Print USING; "v escape ##.###"; vesc2
        ' Locate 3, 40: Debug.Print "v #3 ";: Debug.Print USING; "##.###"; vv(2)
        Form3.Text1(1).Text = Int(vv(0) * 1000) / 1000
        Form3.Text1(2).Text = Int(vv(1) * 1000) / 1000
        If vv(2) > vesc2 Then Form3.Text1(3).ForeColor = l_red Else Form3.Text1(3).ForeColor = Gray
        Form3.Text1(3).Text = Int(vv(2) * 1000) / 1000
        vesc01 = vesc0: lab0 = "Vesc #1": vv01 = vv(0)
        If frac1 > frac0 Then vesc01 = vesc1: lab0 = "Vesc #2": vv01 = vv(1)
        If m3fract < 1 Or m1fract >= bhfract Then vesc = vesc2: lab0 = "Vesc #3": vvx = vv(2) Else vesc = vesc01: vvx = vv01
    
        Form3.Label1(4).Caption = lab0
        Form3.Text1(4).Text = Int(vesc * 1000) / 1000
        If auc = 0 Then
            Form3.Text1(5).Text = Int(Sqr(rrmin))  'Int(Sqr((rr(2, 0) + rr(2, 1)) / 2))
            Form3.Text1(6).Text = Int(Sqr(rrmin201))
        Else
            Form3.Text1(5).Text = Int(Sqr(rrmin) * 100 / au) / 100 'Int(Sqr((rr(2, 0) + rr(2, 1)) / 2))
            Form3.Text1(6).Text = Int(Sqr(rrmin201) * 100 / au) / 100
        End If
    End If
  
    kleur = l_magenta:
        
    If frac0 > 1 And m3fract > 2 Then kleur = black
    If m(0) > 0 Then
        If m3fract <= 1 Or m1fract >= bhfract Then
            Form2.PSet (x0disp + x0(0) * scalex, y0disp - y0(0) * scaley), kleur
            If m1fract >= bhfract Then
                Form2.PSet (x0disp31 + (x0(0) - dist1) * scalex * mul1, y0disp31 - y0(0) * scaley * mul1), kleur
                Form2.PSet (x0disp3 + x0(0) * scalex * mul2, y0disp3 - y0(0) * scaley * mul2), kleur
            End If
        Else
            Form2.PSet (x0disp3 + (x0(0) - x0(2)) * scalex3, y0disp3 - (y0(0) - y0(2)) * scaley3), kleur
            Form2.PSet (x0disp31 + (x0(0) - x0(2)) * scalex3 * mul0, y0disp31 - (y0(0) - y0(2)) * scaley3 * mul0), kleur
        End If
    End If
    kleur = l_green
    If frac1 > 1 And m3fract > 2 Then kleur = black
    If m(1) > 0 Then
        If m3fract <= 1 Or m1fract >= bhfract Then
            Form2.PSet (x0disp + x0(1) * scalex, y0disp - y0(1) * scaley), kleur
            If m1fract >= bhfract Then
                Form2.PSet (x0disp31 + (x0(1) - dist1) * scalex * mul1, y0disp31 - y0(1) * scaley * mul1), kleur
                Form2.PSet (x0disp3 + x0(1) * scalex * mul2, y0disp3 - y0(1) * scaley * mul2), kleur
            End If
        Else
            Form2.PSet (x0disp3 + (x0(1) - x0(2)) * scalex3, y0disp3 - (y0(1) - y0(2)) * scaley3), kleur
            Form2.PSet (x0disp31 + (x0(1) - x0(2)) * scalex3 * mul0, y0disp31 - (y0(1) - y0(2)) * scaley3 * mul0), kleur
        End If
    End If
    kleur = black
    kleur1 = l_blue
    If frac2 > 1 And (m3fract < 1 Or m1fract > bhfract) Then kleur = l_red: kleur1 = l_red
    If m(2) > 0 Then
        If m3fract <= 1 Or m1fract >= bhfract Then
            Form2.PSet (x0disp + x0(2) * scalex, y0disp - y0(2) * scaley), kleur
            If m1fract >= bhfract Then
                Form2.PSet (x0disp31 + (x0(2) - dist1) * scalex * mul1, y0disp31 - y0(2) * scaley * mul1), kleur1
                Form2.PSet (x0disp3 + x0(2) * scalex * mul2, y0disp3 - y0(2) * scaley * mul2), kleur
            End If
       Else
            kleur = l_red
            Form2.PSet (x0disp3 + (x0(2) - x0(2)) * scalex3, y0disp3 - (y0(2) - y0(2)) * scaley3), kleur
            Form2.PSet (x0disp31 + (x0(2) - x0(2)) * scalex3 * mul0, y0disp31 - (y0(2) - y0(2)) * scaley3 * mul0), kleur
        End If
    End If
End If
s9:
DoEvents
aa$ = INKEY$: If aa$ = Chr$(ESC) Then GoTo s10:
If endc = 1 Then Debug.Print "endc"; endc: GoTo s20
If end1 = 1 Then GoTo s10:
GoTo str1

s10:
''If html = 0 Then
If auc = 0 Then
    Debug.Print "Alpha"; alpha; "rmax"; Int(Sqr(rrmax)); "rmin20"; Int(Sqr(rrmin20)); "rmin21"; Int(Sqr(rrmin21)); "rmin201"; Int(Sqr(rrmin201));
    Debug.Print "tcnt"; tcnt; "v"; Int(vv(0)); Int(vv(1)); Int(vv(2));
    Debug.Print "vmax"; Int(vvmax(0)); Int(vvmax(1)); Int(vvmax(2)); lab0; Int(vesc); "n stars"; nstars
Else
    Debug.Print "Alpha"; alpha; "AU rmax"; Int(Sqr(rrmin) * 1000 / au) / 1000; "rmin20"; Int(Sqr(rrmin20) * 1000 / au) / 1000; "rmin21"; Int(Sqr(rrmin21) * 1000 / au) / 1000; "rmin201"; Int(Sqr(rrmin201) * 1000 / au) / 1000;
    Debug.Print "tcnt"; tcnt; "v"; Int(vv(0) * 100) / 100; Int(vv(1) * 100) / 100; Int(vv(2) * 100) / 100;
    Debug.Print "vmax"; Int(vvmax(0) * 100) / 100; Int(vvmax(1) * 100) / 100; Int(vvmax(2) * 100) / 100; lab0; Int(vesc * 100) / 100; "n stars"; nstars
''End If
End If
If html = 1 Then
    If auc = 0 Then
        Debug.Print "<tr><td>"; alpha; "</td><td>"; nstars; "</td><td>"; Int(Sqr(rrmin20)); "</td><td>"; Int(Sqr(rrmin21)); "</td><td>";
        Debug.Print Int(vvmax(0)); "</td><td>"; Int(vvmax(1)); "</td><td>"; Int(vvmax(2)); "</td><td>";
        Debug.Print Int(vv(0)); "</td><td>"; Int(vv(1)); "</td><td>"; Int(vv(2)); "</td><td>"; Int(vesc); "</td></tr>"
    Else
        Debug.Print "<tr><td>"; alpha; "</td><td>"; nstars; "</td><td>"; Int(Sqr(rrmin20) * 1000 / au) / 1000; "</td><td>"; Int(Sqr(rrmin21) * 1000 / au) / 1000; "</td><td>";
        Debug.Print Int(vvmax(0) * 100) / 100; "</td><td>"; Int(vvmax(1) * 100) / 100; "</td><td>"; Int(vvmax(2) * 100) / 100; "</td><td>";
        Debug.Print Int(vv(0) * 100) / 100; "</td><td>"; Int(vv(1) * 100) / 100; "</td><td>"; Int(vv(2) * 100) / 100; "</td><td>"; Int(vesc * 100) / 100; "</td></tr>"
    End If
End If
    
    Form3.Text1(7).Text = alpha
    Form3.Text1(8).Text = Int(vv(0) * 1000) / 1000
    Form3.Text1(9).Text = Int(vv(1) * 1000) / 1000
    If frac2 > 1 Then Form3.Text1(10).ForeColor = l_red Else Form3.Text1(10).ForeColor = Gray
    Form3.Text1(10).Text = Int(vv(2) * 1000) / 1000
    ' If m3fract < 1 Then vesc = vesc2 Else vesc = vesc01
    Form3.Text1(11).Text = Int(vesc * 1000) / 1000
    If auc = 0 Then
        Form3.Text1(12).Text = Int(Sqr(rrmax))  'Int(Sqr((rr(2, 0) + rr(2, 1)) / 2))
        Form3.Text1(13).Text = Int(Sqr(rrmin201))
    Else
        Form3.Text1(12).Text = Int(Sqr(rrmax) * 100 / au) / 100 'Int(Sqr((rr(2, 0) + rr(2, 1)) / 2))
        Form3.Text1(13).Text = Int(Sqr(rrmin201) * 100 / au) / 100
    End If
    If rrmin > rrlimit Then
        If ratio = 0 Or vvx / vesc > ratio Then
            Form3.Text1(14).Text = alpha
            Form3.Text1(15).Text = Int(vv(0) * 1000) / 1000
            Form3.Text1(16).Text = Int(vv(1) * 1000) / 1000
            If vvx > vesc Then Form3.Text1(17).ForeColor = l_red Else Form3.Text1(17).ForeColor = Gray
            Form3.Text1(17).Text = Int(vv(2) * 1000) / 1000
            ' If m3fract < 1 Then vesc = vesc2 Else vesc = vesc0
            Form3.Text1(18).Text = Int(vesc * 1000) / 1000
            If auc = 0 Then
                Form3.Text1(19).Text = Int(Sqr(rrmax))  'Int(Sqr((rr(2, 0) + rr(2, 1)) / 2))
                Form3.Text1(20).Text = Int(Sqr(rrmin201))
            Else
                Form3.Text1(19).Text = Int(Sqr(rrmax) * 100 / au) / 100 'Int(Sqr((rr(2, 0) + rr(2, 1)) / 2))
                Form3.Text1(20).Text = Int(Sqr(rrmin201) * 100 / au) / 100
            End If
            ratio = vvx / vesc
        End If
    End If
    alpha0 = alpha0 + dalpha0:
    
    If manual0 = 1 Then
        manual = 1: end1 = 0
        Form1.CommandNext.Caption = "Restart"
        Do
            DoEvents
            If endc = 2 Then End
        Loop Until manual = 0 Or end1 = 1
    End If
    
    If alpha0 <= alpha0end Then GoTo s1
s20:
  color 14
  Locate ychrmax, 35: Debug.Print "NEXT TEST ? "
  endc = 1
  Do:
    DoEvents
        aa$ = INKEY$:
        If endc = 2 Then Debug.Print "endc"; endc: End
    Loop Until aa$ <> ""
  If aa$ = Chr$(ESC) Then End
  color 15
GoTo s1
End Sub

Sub COORD(m0, m1, dist, x0, x1, vy0, vy1)
 '                                                                    COORD
 ' x0 and vy0 are base position and speed
 ' Debug.Print "COORD"; m0; m1; "dist"; dist; x0; x1; vy0; vy1
 mm01 = m0 + m1
 r0 = dist * m1 / mm01
 r1 = dist - r0
 vr0 = Sqr(G * r0 * m1) / dist
 vr1 = Sqr(G * r1 * m0) / dist
 x1 = x0                             ' same base
 vy1 = vy0                           ' same base
 x0 = x0 - r0
 x1 = x1 + r1
 vy0 = vy0 - vr0
 vy1 = vy1 + vr1
 TT1 = 2 * pi * r1 / vr1
End Sub

Sub GETSCREEN()
'                                                                  GETSCREEN
   fract = 1
   xmax = Form2.Width
   ymax = Form2.Height

End Sub

Public Sub INIT0()
    ' Called from subroutine "WorkLoad"
    Dim distance As String
    trace = 0
    mul_dist2 = 2.2                    ' standard value 2.2
    mul0 = 10: mul1 = 40: mul2 = 200
    '' escape = 0.7                            ' 75 en 90
    '' escape = 0.5                            ' 60 en 75
    escape = 0.4
        
    bhfract = 1000000                        ' 1 million
    G = 6.672E-20                            ' Standard value
    au = 149600000#
    msun = 1.9891E+30                        ' Sun
    listt = 0
    vlimitmax = 300000                       'speed of light
    
    Select Case subtest
    Case 0, 1
        dist1 = 10000
        m1fract = 1
        m2fract = 1
        m3fract = 0.001
        alpha0str = 0
        alpha0end = 180
        dalpha0 = 10
        manual0 = 0
        dist2f = 2.5                            ' m3fract > bhfract
        dist2 = dist1 * dist2f
        tdelta_fact = 2                       ' tdelta multiplier
        If subtest = 0 Then tdelta_fact = 0.5
        auc = 0                               ' Astronomical Units
        html = 0
        ncycle = 0
    Case 2
        dist1 = 1
        m1fract = 1
        m2fract = 1
        m3fract = 0.001
        alpha0str = 0
        alpha0end = 180
        dalpha0 = 10
        manual0 = 0
        dist2f = 2.5                            ' m3fract > bhfract
        dist2 = dist1 * dist2f
        tdelta_fact = 2                       ' tdelta multiplier
        auc = 1                               ' Astronomical Units
        html = 1
        ncycle = 0
     Case Is = 3, 3.5           ' m1=m2  m3 small   was 10 and 10.5
        dist1 = 0.04              ' dist1
        m1fract = 100             ' m(0)
        m2fract = 100             ' m(1)
        m3fract = 0.5
        mul0 = 10
        manual0 = 0
        dist2f = 2
        If subtest = 3.5 Then dist2f = 5               ' dist2 fraction > 1
        dist2 = dist1 * dist2f
        tdelta_fact = 2
        html = 1
        auc = 1
        ncycle = 0                   ' # of cycles
        mul_dist2 = 2.2
        ' alpha0str = -10: alpha0end = 10: dalpha0 = 2      highest alpha = 0
        ' escape = 0.8: alpha0str = 91: alpha0end = 98: dalpha0 = 0.5: tdelta_fact = 20
        ''escape = 0.8: alpha0str = 93: alpha0end = 95: dalpha0 = 1: tdelta_fact = 50
        ''escape = 0.8: alpha0str = 94: alpha0end = 97: dalpha0 = 0.1: tdelta_fact = 50
        alpha0str = 0: alpha0end = 180: dalpha0 = 10
     Case Is = 4                  ' m1=m2  m3 small   was 12
        dist1 = 1                 ' dist1
        m1fract = 100             ' m(0)
        m2fract = 100              ' m(1)
        m3fract = 0.5             ' m(2)
        mul0 = 10
        manual0 = 0
        dist2f = 2                ' dist2 fraction > 1
        dist2 = dist1 * dist2f
        tdelta_fact = 2
        html = 1
        auc = 1
        ncycle = 0                   ' # of cycles
        mul_dist2 = 2.2
        alpha0str = 0: alpha0end = 180: dalpha0 = 10
        
        ' alpha0str = 210: dalpha0 = 1: alpha0end = 220
    
    Case Is = 5, 5.5               'was 2 and 2.5
        alpha0str = 0
        alpha0end = 180
        dalpha0 = 10
        dist1 = 1000000           ' dist1
        m1fract = 1
        m2fract = 1
        m3fract = 100
        mul0 = m3fract / 10       '  m3fract>1
        manual0 = 0
        '  If m3fract > 1 Then dist2 = 2 * dist1 * Sqr(m3fract)
        dist2f = 15
        dist2 = dist1 * 15
        tdelta_fact = 10                       ' tdelta multiplier
        html = 1
        auc = 0                               ' Astronomical Units
        ncycle = 0
        vlimitmax = 1000000                  '3 * c
        alpha0str = 0: alpha0end = 180: tdelta_fact = 10   ' HR
        '  Figure 1C
        If subtest = 5.5 Then
            alpha0str = 165: alpha0end = 172: dalpha0 = 1: tdelta_fact = 10: mol0 = m3fract / 8  ' detail angle 170 HR
        End If
        ' listt = 1: tdelta_fact = 100: alpha0str = 0: alpha0end = 2: dalpha0 = 1: alphaa(0) = 130: alphaa(1) = 150: alphaa(2) = 170
    Case Is = 6, 6.5                 ' m0 m0  1000m0  was 3 and 3.5
        alpha0str = 0
        alpha0end = 180
        dalpha0 = 10
        dist1 = 1000000        ' dist1
        m1fract = 1
        m2fract = 1
        m3fract = 1000
        mul0 = m3fract / 10
        manual0 = 0
        If m3fract > 1 Then dist2 = 2 * dist1 * Sqr(m3fract)
        dist2f = 30
        dist2 = dist1 * 30
        tdelta_fact = 50                       ' tdelta multiplier
        html = 1
        auc = 0
        ncycle = 0
        vlimitmax = 300000                    'c
        ' alpha0str = 170: tdelta_fact = 50: subtest = 6.5     ' extra code in INITIALISE ! special display
        If subtest = 6.5 Then
            alpha0str = 160: dalpha0 = 2: tdelta_fact = 50:
            vlimitmax = 1000000                    '3 * c
        End If
        ' alpha0str = 170: manual0 = 1: tdelta_fact = 50
        ' alpha0str = 172: manual0 = 1: tdelta_fact = 50
    Case Is = 7                           ' was 4
        alpha0str = 0         ' BH  m0  m0
        alpha0end = 180
        dalpha0 = 10
        dist1 = 1000000             ' dist1  in AU
        m1fract = 1
        m2fract = 1
        m3fract = 10000
        mul0 = m3fract / 10
        If m1fract > 100 Then dist2 = dist1 * 10 * Sqr(m1fract) ^ (1 / 4)
        dist2f = 10 * Sqr(m1fract) ^ (1 / 4)
        dist2f = 50
        dist2 = dist1 * 50
        tdelta_fact = 10                       ' tdelta multiplier
        html = 1
        auc = 0                               ' Astronomical Units
        ncycle = 0
        manual0 = 0
        vlimitmax = 1000000                  '3 * c
    Case Is = 8                     ' large BH in m0  was 6
        alpha0str = 350.621
        alpha0end = 350.628
        dalpha0 = 0.0005
        dist1 = 1000                ' dist1 in AU
        m1fract = 4000000
        m2fract = 1
        m3fract = 1
        mul0 = 10
        manual0 = 1
        dist2f = 1.1                ' dist2 fraction > 1
        dist2 = dist1 * dist2f
        tdelta_fact = 800
        html = 1
        auc = 1
        ncycle = 3
        alpha0end = 350.625: alpha0str = 350.6225
        ncycle = 2: dalpha0 = 0.0005: manual0 = 0: tdelta_fact = 100
    Case Is = 9                     ' large BH in m0
        dist1 = 1000                 ' dist1 in AU
        m1fract = 4000000            'm(0)
        m2fract = 100                'm(1)
        m3fract = 1
        mul0 = 10
        manual0 = 0
        dist2f = 1.1                ' dist2 fraction > 1
        dist2 = dist1 * dist2f
        tdelta_fact = 100
        html = 0
        auc = 1
        ncycle = 0                   ' # of cycles
        mul2 = 40
        alpha0str = 350.614: alpha0end = 350.632: dalpha0 = 0.001
        alpha0str = 350.616: mul_dist2 = 2.5: ncycle = 3: manual0 = 1: html = 1: tdelta_fact = 100: m2fract = 100   ' one test
        alpha0str = 350.628: mul_dist2 = 8: ncycle = 6: manual0 = 1: html = 1: tdelta_fact = 100: m2fract = 100   ' one test
        alpha0str = 350.616: alpha0end = 350.62805: dalpha0 = 0.002: mul_dist2 = 2.2: ncycle = 2: manual0 = 0: tdelta_fact = 25
    Case Is = 10                     ' large BH in m0   was 13
        dist1 = 10000               ' dist1 in AU
        m1fract = 4000000           'm(0)
        m2fract = 100               'm(1)
        m3fract = 1
        mul0 = 10
        manual0 = 0
        dist2f = 1.4                ' dist2 fraction > 1
        dist2 = dist1 * dist2f
        tdelta_fact = 2                       ' tdelta multiplier
        html = 1
        auc = 1
        ncycle = 2                   ' # of cycles
        mul2 = 200
        alpha0str = 325:     alpha0end = 329:     dalpha0 = 0.2:   tdelta_fact = 5
        alpha0str = 325.38:  alpha0end = 325.5:   dalpha0 = 0.02:  tdelta_fact = 5
        alpha0str = 325.43:  alpha0end = 325.44:  dalpha0 = 0.001: tdelta_fact = 10
        alpha0str = 325.432: alpha0end = 325.439: dalpha0 = 0.001: tdelta_fact = 10
     
     Case Is = 11                     ' large BH in m0   was 14
        dist1 = 300               ' dist1 in AU
        m1fract = 4000000           'm(0)
        m2fract = 20               'm(1)
        m3fract = 1
        mul0 = 10
        manual0 = 0
        dist2f = 1.4                ' dist2 fraction > 1
        dist2 = dist1 * dist2f
        tdelta_fact = 2                       ' tdelta multiplier
        html = 1
        auc = 1
        ncycle = 2                   ' # of cycles
        mul2 = 200
        alpha0str = 323:     alpha0end = 329:       dalpha0 = 0.5: tdelta_fact = 5
        alpha0str = 324.6:   alpha0end = 325.5:     dalpha0 = 0.1: tdelta_fact = 5
        alpha0str = 325.3:   alpha0end = 325.5:     dalpha0 = 0.01:  tdelta_fact = 20
        alpha0str = 325.432: alpha0end = 325.439:   dalpha0 = 0.001: tdelta_fact = 25
        alpha0str = 325.434: alpha0end = 325.437:   dalpha0 = 0.0003: tdelta_fact = 50
        alpha0str = 325.435: alpha0end = 325.43701: dalpha0 = 0.00025: tdelta_fact = 60
        
    
    Case 101
        G = 1
        alpha0str = 0
        alpha0end = 180
        dalpha0 = 10
        tdelta = 0.005                         ' delta time
        dist1 = 200
        m1fract = 1
        m2fract = 1
        m3fract = 0.001
        mul0 = 10
        dist2f = 2.5
        dist2 = dist1 * 2.5
        tdelta_fact = 2                       ' tdelta multiplier
        html = 0
        auc = 0                               ' Astronomical Units
        ncycle = 0
        distance = Str$(dist1)
        msun = 1000
    Case Is = 105
        alpha0str = 0         ' BH  m0  m0
        alpha0end = 180
        dalpha0 = 10
        dist1 = 1000000             ' dist1  in AU
        m1fract = 100
        m2fract = 100
        m3fract = 4000000
        mul0 = m3fract / 10
        If m1fract > 100 Then dist2 = dist1 * 10 * Sqr(m1fract) ^ (1 / 4)
        dist2f = 10 * Sqr(m1fract) ^ (1 / 4)
        dist2f = 50
        dist2 = dist1 * 50
        tdelta_fact = 10                       ' tdelta multiplier
        html = 1
        auc = 0                               ' Astronomical Units
        ncycle = 0
        manual0 = 0
    Case Is = 107                     ' small BH in m0
        alpha0str = 350.59
        alpha0end = 350.64
        dalpha0 = 0.005
        dist1 = 1000                ' dist1 in AU
        m1fract = 40000             ' small BH
        m2fract = 1
        m3fract = 1
        mul0 = 10
        manual0 = 0
        dist2f = 1.1                ' dist2 fraction > 1
        dist2 = dist1 * dist2f
        tdelta_fact = 80
        bhfract = 10000
        html = 1
        auc = 1
        ncycle = 3
    Case Is = 108                     ' large BH in m0
        alpha0str = 350.628
        alpha0end = 350.65
        dalpha0 = 0.002
        dist1 = 1000                ' dist1 in AU
        m1fract = 4000000           'm(0)
        m2fract = 50                'm(1)
        m3fract = 1
        mul0 = 10
        manual0 = 0
        dist2f = 1.1                ' dist2 fraction > 1
        dist2 = dist1 * dist2f
        tdelta_fact = 40
        html = 0
        auc = 1
        ncycle = 0
        ' alpha0str = 350.6: ncycle = 3: manual0 = 1: html = 1: tdelta_fact = 10     ' one test
        alpha0str = 350.616: ncycle = 3: manual0 = 1: html = 1: tedelta_fact = 40  ' one test
        alpha0str = 350.63: ncycle = 3: manual0 = 1: html = 1: tedelta_fact = 40   ' one test
     Case Is = 111                     ' m1=m2  m3 small
        dist1 = 1                 ' dist1
        m1fract = 100             ' m(0)
        m2fract = 25              ' m(1)
        m3fract = 0.5             ' m(2)
        mul0 = 10
        manual0 = 0
        dist2f = 2                ' dist2 fraction > 1
        dist2 = dist1 * dist2f
        tdelta_fact = 2
        html = 1
        auc = 1
        ncycle = 0                   ' # of cycles
        mul_dist2 = 2.2
        alpha0str = 0: alpha0end = 360: dalpha0 = 10
        
        ' alpha0str = 210: dalpha0 = 1: alpha0end = 220
     
       
    Case Else
    End Select
        
    m0(0) = m1fract * msun
    m0(1) = m2fract * msun
    m0(2) = m3fract * msun
    
    distance = Str(dist1)
    distance1 = Str(dist2)
    'If auc = 1 Then distance = distance + " AU"
    'If auc = 1 Then distance1 = distance1 + " AU"
    Form1.Text1(3).Text = distance
    Form1.Text1(4).Text = distance1
    
    ' Form1.Text1(4).Text = m3fract
    Form1.Text1(0).Text = m1fract
    Form1.Text1(1).Text = m2fract
    Form1.Text1(2).Text = m3fract
    
    Form1.Text1(5).Text = ""
    Form1.Text1(6).Text = ""
    Form1.Text1(7).Text = ""
    Form1.Text1(8).Text = ""
    Form1.Text1(9).Text = ""
    ' Form1.Text1(10).Text = Str(subtest)
    Form1.Text1(11).Text = alpha0str
    Form1.Text1(12).Text = alpha0end
    Form1.Text1(13).Text = Str(tdelta_fact)
    Form1.Text1(14).Text = dalpha0
    If auc = 0 Then Form1.Option1(0).Value = False Else Form1.Option1(0).Value = True
    
    alpha0 = alpha0str
    
    Debug.Print "INIT0 dist1"; dist1; "dist2f"; dist2f; "dist2"; dist2; "m1fract"; m1fract; "m2fract"; m2fract; "m3fract"; m3fract
    Debug.Print "INIT0 subtest"; subtest; "alpha0"; alpha0str; alpha0end; dalpha0; "tdeltafact"; tdelta_fact
    Debug.Print "INIT0 html"; html; "auc"; auc; "ncycle"; ncycle; "mul1"; mul1; "mul2"; mul2; "mul_dist2"; mul_dist2

End Sub
Public Sub INIT1()
        Dim distance As String
    
        If auc = 1 Then
            dist1 = dist1 * au   ' distance in AU
            dist2 = dist2 * au   ' distance in AU
        End If
        
        distance = Form1.Text1(3).Text
        distance = RTrim$(distance)
        l1 = Len(distance)
        auc = 0
        If l1 > 2 Then
            temp = UCase$(Mid$(distance, l1 - 2, 2))
            If UCase$(Mid$(distance, l1 - 1, 2)) = "AU" Then
                auc = 1
                distance = Mid$(distance, 1, l1 - 2)
                distx = Val(distance)
                If auc = 1 Then
                    dist1 = distx * au   ' distance in AU
                End If
           End If
        End If
        
        distance1 = Form1.Text1(4).Text
        distance1 = RTrim$(distance1)
        l1 = Len(distance1)
        auc1 = 0
        If l1 > 2 Then
            temp = UCase$(Mid$(distance1, l1 - 2, 2))
            If UCase$(Mid$(distance1, l1 - 1, 2)) = "AU" Then
                auc1 = 1
                distance1 = Mid$(distance1, 1, l1 - 2)
            End If
        End If
        distx = Val(distance1)
        If auc1 = 1 Then
            dist2 = distx * au   ' distance in AU
        End If
        
        dist2f = dist2 / dist1
        
        For t1 = 0 To 2
            str1 = Form1.Text1(t1).Text
            l = Len(str1)
            For i = 1 To l
                If Mid$(str1, i, 1) = "," Then Mid$(str1, i, l) = "."
            Next i
            Select Case t1
            Case Is = 0
                m1fract = Val(str1)
            Case Is = 1
                m2fract = Val(str1)
            Case Is = 2
                m3fract = Val(str1)
            End Select
            Form1.Text1(t1).Text = str1
        Next t1
    
        alpha0str = Val(Form1.Text1(11).Text)
        alpha0end = Val(Form1.Text1(12).Text)
        Getval Form1.Text1(13).Text, tdelta_fact
        dalpha0 = Val(Form1.Text1(14).Text)
        auc = 0
        If Form1.Option1(0).Value = True Then auc = 1
    
    If subtest = 1 Then
        ''dist2 = dist1 * 2.5
    Else
        ''dist2 = dist1 * 3
    End If

    alpha0 = alpha0str
    
    If m1fract < bhfract Then
        ' m0(2) = m0(0) * m3fract     ' m(2) = Black hole
    Else
        ' m0(0) = m0(0) * m3fract     ' m(0) = Black hole
    End If

    If subtest = 0 Then
        m1fract = 1
        If m3fract > 1 Then dist2 = 2 * dist1 * Sqr(m3fract)
        If m3fract > 100 Then dist2 = dist1 * 10 * Sqr(m3fract) ^ (1 / 4)
        If m3fract >= bhfract Then
            dist2 = 1.5 * dist1             ' dist2 fraction
            m1fract = m3fract: m3fract = 1
        End If
        m0(0) = m1fract * msun
        m0(1) = m2fract * msun
        m0(2) = m3fract * msun
        mul0 = m3fract / 10
    End If
    
    Debug.Print "INIT1 "; "dist1"; dist1; "dist2"; dist2; "auc"; auc; "mfract"; m1fract; m2fract; m3fract; "subtest"; subtest; "distance"; distance; distance1
    Debug.Print "INIT1 ";

End Sub
Public Sub INITIALISE()
    
    stars = 3
    scren% = 12                             ' screen mode
    end1 = 0:
    alpha = alpha0                         ' alpha for test 13
    initcond = 1                           ' 1 = towards  -1 = away
    dispcond = 100                         ' display condition
                
    For i = 0 To stars - 1
        x0(i) = 0                     ' initial positions
        y0(i) = 0                     ' initial positions
        vx0(i) = 0                    ' initial velocity
        vy0(i) = 0                    ' initial velocity
        m(i) = m0(i)
    Next i

  
GETSCREEN                         ' Get screen parameters

    alpha = alpha0                       ' alpha for test 13
    COORD m(0), m(1), dist1, x0(0), x0(1), vy0(0), vy0(1)
    agrad = alpha * pi / 180
    r1 = Abs(x0(1)): v1 = Abs(vy0(1))
    x0(1) = r1 * Cos(agrad): y0(1) = r1 * Sin(agrad)
    vx0(1) = v1 * Cos(agrad + pi / 2): vy0(1) = v1 * Sin(agrad + pi / 2)
    r0 = Abs(x0(0)): v0 = Abs(vy0(0))
    x0(0) = r0 * Cos(agrad + pi): y0(0) = r0 * Sin(agrad + pi)
    vx0(0) = v0 * Cos(agrad + 1.5 * pi): vy0(0) = v0 * Sin(agrad + 1.5 * pi)
    x0(2) = dist2                  ' far away
    dist20 = Abs(x0(2) - x0(0)): dist21 = Abs(x0(2) - x0(1))
    If m1fract >= bhfract Then                         ' BH in center
        vx0(2) = -initcond * escape * Sqr(2 * G * (m(0) / dist20))
    Else
        vx0(2) = -initcond * escape * Sqr(2 * G * (m(0) / dist20 + m(1) / dist21))
        If m3fract >= 1 Then
            vx0(2) = 0                         ' m(2) large
            vesc = escape * Sqr(2 * G * m(2) / dist20)
            vx0(0) = vx0(0) + vesc
            vx0(1) = vx0(1) + vesc
        End If
    End If
    
    x0disp = xmax / 2: y0disp = ymax / 2
    scalex = xmax / (mul_dist2 * dist2): scaley = scalex
    x0disp3 = 0.9 * xmax: y0disp3 = 0.25 * ymax:      ' top part
    x0disp31 = 0.5 * xmax: y0disp31 = 0.65 * ymax     ' bottom part  BH centered
    scalex3 = xmax / (1.3 * dist2): scaley3 = scalex3
    
    rrmin201 = x0(2) ^ 2
    rrmin20 = rrmin201: rrmin21 = rrmin201                ' minimumdistus #1 and #2
    If m1fract >= bhfract Then
        x0disp = xmax / 2: y0disp = ymax / 2
        scalex = xmax / (mul_dist2 * dist2): scaley = scalex
        x0disp3 = 0.5 * xmax: x0disp31 = 0.5 * xmax
        y0disp3 = 0.25 * ymax: y0disp31 = 0.75 * ymax
    Else
        If m3fract > 1 Then
            x0disp = x0disp * 0.25: y0disp = 0.25 * ymax
            scalex = xmax / (1.4 * dist2): scaley = scalex
        End If
    End If
    
    ' See subtest 6
    If subtest = 6.5 Then
        scalex3 = scalex3 * 4: mul0 = mul0 / 4: x0disp31 = 0.9 * xmax:
        If alpha = 170 Then y0disp3 = 0.15 * ymax: y0disp31 = 0.35 * ymax:
        If alpha = 180 Then y0disp3 = 0.55 * ymax: y0disp31 = 0.75 * ymax:
    End If
    
    ' Debug.Print x0disp; y0disp; x0disp3; y0disp3; x0disp31; y0disp31: End
    
    dist22 = dist2 * dist2
    
    TT = 2 * pi * dist1 / v1                    '  2 * pi
    tdelta = TT / 600000                        '  delta t
    tdelta = tdelta / tdelta_fact               '  improve accuracy
    ' vesc = sqr(2GM/R) = sqr(2GM/vesc*dt)  vesc^3=2GM/dt
    bhstar = 0: star1 = 1: star2 = 2
    If m(1) > m(0) Then bhstar = 1: star1 = 0: star2 = 2
    If m(2) > m(bhstar) Then temp = bhstar: bhstar = star2: star2 = temp
        vbh = 2 * G * m(bhstar) / tdelta:
        vlimit = vbh ^ (1 / 3)                    ' maximum speed
        rlimit = vlimit * tdelta:
        If vlimit > vlimitmax Then vlimit = vlimitmax: rlimit = 2 * G * m(bhstar) / vlimit ^ 2
        rrlimit = rlimit ^ 2             ' minimum distance collision
        rr2limit(bhstar, star1) = rrlimit: rr2limit(star1, bhstar) = rrlimit
        rr2limit(bhstar, star2) = rrlimit: rr2limit(star2, bhstar) = rrlimit
        rrmin = rrlimit
        rrmint0 = rrmin: rrmint1 = rrmin
    
    
    If m(star2) > m(star1) Then
        v3 = 2 * G * m(star2) / tdelta:
        mx = m(star2)
    Else
        v3 = 2 * G * m(star1) / tdelta
        mx = m(star1)
    End If
    v3limit = v3 ^ (1 / 3):                     ' maximum speed
    r3limit = v3limit * tdelta:
    If v3limit > vlimitmax Then v3limit = vlimitmax: r3limit = 2 * G * mx / v3limit ^ 2
    rr3limit = r3limit ^ 2             ' minimum distance collision
    rr2limit(star1, star2) = rr3limit: rr2limit(star2, star1) = rr3limit
    
    
    ' Debug.Print alpha; vlimit; rlimit; rlimit_bh; distance; "auc"; auc; l1; temp
    If alpha0 = alpha0str Then
        If auc = 0 Then
            Debug.Print "INITIALISE dist1 "; dist1; "dist2 "; dist2; "m3fract"; m3fract; "m1fract"; m1fract; "vlimit"; Int(vlimit); "rlimit"; Int(Sqr(rrlimit) * 100) / 100
            Debug.Print "INITIALISE TT1"; Int(TT1); "TT"; Int(TT * 10 ^ 3) / 10 ^ 3; "tdelta"; Int(tdelta * 10 ^ 7) / 10 ^ 7; "escape"; escape; "mul0"; mul0
        Else
            Debug.Print "INITIALISE AU dist1 "; dist1 / au; "dist2 "; dist2 / au; "m3fract"; m3fract; "m1fract"; m1fract; "vlimit"; Int(vlimit); "rlimit"; Int(Sqr(rrlimit) * 100000 / au) / 100000
            Debug.Print "INITIALISE TT1"; Int(TT1); "TT"; Int(TT * 10 ^ 3) / 10 ^ 3; "tdelta"; Int(tdelta * 10 ^ 7) / 10 ^ 7; "escape"; escape; "mul0"; mul0
        End If
    End If
    
  For i = 0 To stars - 1
    x00(i) = x0(i)                   ' initial positions
    y00(i) = y0(i)                   ' initial positions
    vx00(i) = vx0(i)                 ' initial velocity
    vy00(i) = vy0(i)                 ' initial velocity
  Next i
  state = 0
  
  If trace = 1 Then
  
  Debug.Print "INITIALISE "; m(0); m(1); m(2); subtest
  Debug.Print "x"; x0(0); x0(1); x0(2); y0(0); y0(1); y0(2)
  Debug.Print "vx"; vx0(0); vx0(1); vx0(2); vy0(0); vy0(1); vy0(2)
  Debug.Print "r"; Sqr(x0(0) ^ 2 + y0(0) ^ 2); Sqr(x0(1) ^ 2 + y0(1) ^ 2); Sqr(x0(2) ^ 2 + y0(2) ^ 2);
  Debug.Print "vr"; Sqr(vx0(0) ^ 2 + vy0(0) ^ 2); Sqr(vx0(1) ^ 2 + vy0(1) ^ 2); Sqr(vx0(2) ^ 2 + vy0(2) ^ 2)
  
  End If
    
skip5:
  
  Exit Sub
  

  End


End Sub

Public Sub color(i)

End Sub



Sub Screen(i)

End Sub
Sub Locate(i, j)

End Sub



Public Sub Getval(in1, out1)
save = in1
l = Len(save)
For i = 1 To l
   If Mid$(save, i, 1) = "," Then Mid$(save, i, 1) = "."
Next
out1 = Val(save)
End Sub
